{
    MP3Player - Free Delphi Component

    Copyright (C) 1999 shigeo
    Converted by Kei Ishida

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit MPCPUSpc;

interface

const
  tFPU =      (1 shl 0); //
  tMMX =	    (1 shl 1); //
  t3DN =	    (1 shl 2); //
  tSSE =	    (1 shl 3); //
  tCMOV	=     (1 shl 4); //
  tE3DN	=     (1 shl 5); //	/* Athlonp(Externd 3D Now!) */
  tEMMX =     (1 shl 6); //  /* EMMX=E3DNow!_INT=SSE_INT  */

  tINTEL =    (1 shl 8); //
  tAMD =      (1 shl 9); //
  tCYRIX =    (1 shl 10); //
  tIDT =      (1 shl 11) ; //
//  tMULTI = (1 shl 12)	/* for Multi-threaded encoder. */
//		/* Never set on UP or in the binary linked w/o multithread lib. */
  tUNKNOWN =  (1 shl 15); //	/* x_[s */
//  tSPC1 (1 shl 16)	/* ʂȃXCb` */
//  tSPC2 (1 shl 17)	/* pr͌܂ĂȂ */

  tFAMILY4 =  (1 shl 20); //	/* 486 ̎x_[͓ĂɂȂȂ */
  tFAMILY5 =	(1 shl 21); //	/* 586 (P5, P5-MMX, K6, K6-2, K6-III) */
  tFAMILY6 =	(1 shl 22); //	/* 686ȍ~ P-Pro, P-II, P-III, Athlon */

//  CPUSpecs L̒l̘_aŕԂ
function  CPUSpecs: LongInt;

implementation

{$link 'haveunit.obj'}

function  _haveUNIT: LongInt; cdecl; external;
procedure _setPIII_round; cdecl; external;

var
  _CPUSpecsResult: LongInt = 0;

function CPUSpecs: LongInt;
begin
  if _CPUSpecsResult = 0 then begin
    _CPUSpecsResult := _haveUNIT;
    if (_CPUSpecsResult and tSSE) <> 0 then begin
      try
        _setPIII_round;
      except
        _CPUSpecsResult := _CPUSpecsResult and (not tSSE);
      end;
    end;
  end;

  Result := _CPUSpecsResult;
end;

end.
